#include <windows.h>
#include <detours.h>
#include <iostream>
#include <fstream>
#include <Guiddef.h>


#include "stdafx.h"
#include "Rot.h"
#include "Utils.h"

using namespace std;

wchar_t* clsid_str;


static HRESULT (WINAPI * CoCreateInstanceReal)( __in   REFCLSID rclsid,
											    __in   LPUNKNOWN pUnkOuter,
											    __in   DWORD dwClsContext,
											    __in   REFIID riid,
											    __out  LPVOID *ppv
								    	      ) = CoCreateInstance;

HRESULT WINAPI CoCreateInstanceHooked(__in   REFCLSID rclsid,                                                                                                                                     
							          __in   LPUNKNOWN pUnkOuter,
							          __in   DWORD dwClsContext,
							          __in   REFIID riid,
							          __out  LPVOID *ppv
							         )
{
 
	HRESULT hr = CoCreateInstanceReal(rclsid,
						              pUnkOuter,
						              dwClsContext,
						              riid,
						              ppv);

	if(hr == S_OK)
		CheckInterafce((IUnknown*)*ppv, riid);

	return hr;
}

BOOL WINAPI DllMain(HINSTANCE hinst, DWORD reason, LPVOID reserved)
{
	if ( reason == DLL_PROCESS_ATTACH )
	{
		DetourTransactionBegin();
		DetourUpdateThread(GetCurrentThread());
		DetourAttach(&(PVOID&)CoCreateInstanceReal, CoCreateInstanceHooked);
		DetourTransactionCommit();
	}

	else if ( reason == DLL_PROCESS_DETACH )
	{
		DetourTransactionBegin();
		DetourUpdateThread(GetCurrentThread());
		DetourDetach(&(PVOID&)CoCreateInstanceReal, CoCreateInstanceHooked);
		DetourTransactionCommit();

	}
	return true;
}
